/* Gestionnaire de validation de formulaire */
/* gestionnaire pour le transfert de liste à liste d'éléments checkés*/

function formGetCheckedElement(tagFrom){
/* renvoit la liste des checkbox selectionne pour le formulaire tagFrom*/
	var checked=new Array();
	for (var i=0; i< tagFrom.length; i++){
		var check=new Object;
		a = tagFrom.elements[i];
		if (a.checked){
			check['name'] = a.name;
			check['value'] = a.value;
			checked.push(check);
		}
	}
	return checked;
}
function formTransferAllList(from, to){
	tagFrom = $(from);
    tagTo = $(to);
    tags = formGetListElements(tagFrom);
	for (var i=0; i< tags.length; i++){
        a = tags[i];
        input = "<input type='checkbox' name='"+a.name+"' value='"+a.value+"'   >"+ a.name+"</input>";
        trtag = document.getElementById(a.name);
        trtag.parentNode.removeChild(trtag);
        tagTo.innerHTML += "<tr id='"+a.name+"'><td>"+input+"</td></tr>";
    }
}
function formTransferListElement(from, to){
/* transfert les éléments sélectionnés du formulaire from vers le tableau to */
    tagFrom = $(from);
    tagTo = $(to);
    checked = formGetCheckedElement(tagFrom);
    for (var i=0; i< checked.length; i++){
        a = checked[i];     
        input = "<input type='checkbox' name='"+a.name+"' value='"+a.value+"'	>"+ a.name+"</input>";
        trtag = document.getElementById(a.name);
        trtag.parentNode.removeChild(trtag);
        tagTo.innerHTML += "<tr id='"+a.name+"'><td>"+input+"</td></tr>";        
    }
}
function formSelectInvert(p_oForm) {
/* selectionne l'inverse pour le formulaire */
    _form = $(p_oForm);
    for (var i = 0; i < _form.length; i++) {
        _form.elements[i].checked = !_form.elements[i].checked;
    }
}
function formSelectNone(p_oForm) {
/* selection vide pour le formulaire*/
    _form = $(p_oForm);
    for (var i = 0; i < _form.length; i++) {
        _form.elements[i].checked = false;
    }
}
function formSelectAll(p_oForm) {
/* selectionne tous les éléments du formulaire */
    _form = $(p_oForm);
    for (var i = 0; i < _form.length; i++) {
        _form.elements[i].checked = true;
    }
}
function formGetListElements(tagFrom){
	/* renvoit la liste des éléments présents dans les parties droites et gauches*/
	var valids=new Array();
	for (var i=0; i< tagFrom.length; i++){
		var valid=new Object;
		a = tagFrom.elements[i];
		valid['name'] = a.name;
		valid['value'] = a.value;
		valids.push(valid);
	}
	return valids;
}
function formValidForm(server, actionName, forms, balise, params){
	// valide les formulaires : forms = [liste de formulaire] 
	// renvoit un objet {Nom du form:[{name:nomdevariable, value:valeur, 
						//checked:'true'/'false'(que pour ceux qui ont l'attr)}]}
    // balise: balise html de la page ou placer la réponse
    // params: paramètres autres à passer directement
	var result = new Object();
	var i = 0;
	for (i=0; i<forms.length; i++){
		formname = forms[i];
		form = $(formname);
	    if (form != null){
		var formResult = new Array();
		for (j=0; j<form.elements.length; j++){
				var valid = new Object();
				nom = form.elements[j].name;
				val = form.elements[j].value;
				if (form.elements[j].getAttributeNode('_blur') != null){
						a = form.elements[j].getAttributeNode('_blur').value;
						b = eval(a);
						if (!(b)){ stopLoader();return;}
					}
				if ((form.elements[j].type == 'select-multiple')){
				// si on a un select multiple on doit aller chercher les valeurs selectionnees
					select = form.elements[j];
					val = new Array();
					for (k=0; k<select.options.length;k++){
						if (select.options[k].selected){val.push(select.options[k].value);}
					}
				}
				if (form.elements[j].type == 'checkbox'){
				// si on a une checkbox
					checked = form.elements[j].checked;
					valid['checked'] = String(checked);
				}
				if (form.elements[j].type == 'radio'){
				// si on a un bouton radio, il a un attribut checked
					checked = form.elements[j].checked;
					valid['checked'] = String(checked);
				}
				valid['name'] = nom;
				valid['value'] = val;
				formResult.push(valid);
			}
			result[formname] = formResult;
		}
	    }
		var return_json = new Object();
		return_json['form_result'] = result
		return_json = return_json.toJSONString();
        return_params = new Array();
        return_params.push(['JSONstr', return_json]);
        if (params!=undefined){ return_params.push(params);}
//		call_plugin(server, actionName, [['JSONstr', return_json]], balise);
        call_plugin(server, actionName, return_params, balise);
}
function formValidFormByKey(server, actionName, forms){
	// valide les formulaires par le clavier : forms = [liste de formulaire] 
	// renvoit un objet {Nom du form:[{name:nomdevariable, value:valeur, 
						//checked:'true'/'false'(que pour ceux qui ont l'attr)}]}
	var result = new Object();
	var i = 0;
	for (i=0; i<forms.length; i++){
		formname = forms[i];
		form = $(formname);
	    if (form != null){
		var formResult = new Array();
		for (j=0; j<form.elements.length; j++){
				var valid = new Object();
				nom = form.elements[j].name;
				val = form.elements[j].value;
				if (form.elements[j].getAttributeNode('_blur') != null){
						a = form.elements[j].getAttributeNode('_blur').value;
						b = eval(a);
						if (!(b)){ stopLoader();return false;}
					}
				if ((form.elements[j].type == 'select-multiple')){
				// si on a un select multiple on doit aller chercher les valeurs selectionnees
					select = form.elements[j];
					val = new Array();
					for (k=0; k<select.options.length;k++){
						if (select.options[k].selected){val.push(select.options[k].value);}
					}
				}
				if (form.elements[j].type == 'checkbox'){
				// si on a une checkbox
					checked = form.elements[j].checked;
					valid['checked'] = String(checked);
				}
				if (form.elements[j].type == 'radio'){
				// si on a un bouton radio, il a un attribut checked
					checked = form.elements[j].checked;
					valid['checked'] = String(checked);
				}
				valid['name'] = nom;
				valid['value'] = val;
				formResult.push(valid);
			}
			result[formname] = formResult;
		}
	    }
		var return_json = new Object();
		return_json['form_result'] = result
		return_json = return_json.toJSONString();
		call_plugin(server, actionName, [['JSONstr', return_json]]);
}
function formConfirmValid(msg, server, actionName, forms){ // desuette
		var a = confirm(msg);
		if (a){
			formValidForm(server, actionName, forms);
		}
		else{
			window.alert('annuler');
		}
}
function formConfirmExecute(msg, func){
                var a = confirm(msg);
                if (a){ 
                        eval(func);
                }
}
function formAddNameToList1(name, to){
// ajoute le contenu d'un input à un tableau de checkbox avec sticky bit (pour horus)
	tag = $(name);
	tagTo = $(to);
	val = tag.value;
	if ($(val) == undefined){
		input = "<input type='checkbox' name='"+val+"' value='"+val+"'	>"+ val+"</input>";
		sticky = "<input type='checkbox' name='sticky"+val+"' checked='false' value='"+val+"'></input>";
		tagTo.innerHTML += "<tr id='"+val+"'><td>"+input+sticky+" sticky bit activé</td></tr>";
	}
}
function formAddNameToList2(name, to){
// ajoute le contenu d'un input à un tableau de checkbox sans sticy bit
	tag = $(name);
	tagTo = $(to);
	val = tag.value;
	if ($(val) == undefined){
		input = "<input type='checkbox' name='"+val+"' value='"+val+"'	>"+ val+"</input>";
		tagTo.innerHTML += "<tr id='"+val+"'><td>"+input+"</td></tr>";
	}
}
function formAddNameToList3(name, to){
// ajoute le contenu d'un select à un tableau de checkbox sans sticy bit
	tag = $(name);
	tagTo = $(to);
	val = tag.options[tag.selectedIndex].value;
    tag.options[tag.selectedIndex].parentNode.removeChild(tag.options[tag.selectedIndex])
	if ($(val) == undefined){
		input = "<input type='checkbox' name='"+val+"' value='"+val+"'	>"+ val+"</input>";
		tagTo.innerHTML += "<tr id='"+val+"'><td>"+input+"</td></tr>";
	}
}
function formRemoveFromList(from){
// supprime une ligne d'un tableau
	tag = $(from);
	checked = formGetCheckedElement(tag);
	for (i=0; i<checked.length;i++){
		name = checked[i].name;
		if (name.substr(0,6)!='sticky'){
		rmtag = $(name);
		rmtag.parentNode.removeChild(rmtag);}
	}
}
function formCheckActif(formname){
	form = $(formname);
	count = form.elements.length;
	for (i=0; i<count ; i++){
		if (form.elements[i].value == 'actif'){
				form.elements[i].checked = 'true';
			}
	}
}
function formCheckInactif(formname){
	form = $(formname);
	count = form.elements.length;
	for (i=0; i<count ; i++){
		if (form.elements[i].value == 'inactif'){
				form.elements[i].checked = 'true';
			}
	}
}
